// Set time delay (in seconds)
var timeDelay = 6;

// Disable automatic advancement of slides
var autoAdvance = true;

// Function returns a random number between 1 and n
function rand(n){return(Math.floor(Math.random()*n+1));}

jQuery(document).ready(function(){
 
  // Disable title HTML attribute for slider images
  jQuery('.promo_slider img').removeAttr('title');

  // Get all instances of promo_slider on page
  var sliders = jQuery('div.promo_slider');
  
  jQuery.each(sliders, function(){

	// Define current slider
	var current_slider = this;
	
	// Get all panels
    var panels = jQuery('.panel', this);
	
	// Get total count of panels
    var total_items = panels.length;
	
	// Generate numbers for nav
	var navNums = '';
	var i = 1;
	jQuery.each(panels, function(index, object){
	  newNum = '<span title="' + jQuery(object).attr('value') + '">' + jQuery(object).attr('value') + '</span>';
	  if(i != total_items){newNum = newNum + ' | ';}
	  navNums = navNums + newNum;
	  i++;
	});
	
	// Insert numbers into nav
	jQuery('.slider_selections', this).html(navNums);
	
	// Slide navigation
	var slideNav = jQuery('.slider_selections span', this);
	jQuery.each(slideNav, function(index, object){
	  jQuery(object).click(function(){
		
		// Get number for new panel
		var new_value = jQuery(object).attr('title');
		
		// Assign variables for ease of use
		var cur_item = jQuery('.current', current_slider);
		var new_item = jQuery('.panel-' + new_value, current_slider);
		
		// Find number of current panel
		var current_value = jQuery(cur_item).attr('value');
		
		// Add / Remove classes
		cur_item.removeClass('current');
		new_item.addClass('current');
		
		// Fade in / out
		cur_item.fadeOut('fast', function(){
		  new_item.fadeIn('fast');
		});
		
	  });
	});
	
	// Set number for first panel
	var start_value = rand(total_items);
	
	// Hide all panels
	jQuery('.panel', this).hide();
	
	// Show initial panel
	jQuery('.panel-' + start_value, this).show();
	
	// Set rel attribute to 'current'
	jQuery('.panel-' + start_value, this).addClass('current');
	
	// Create click functions for navigational divs
	jQuery('.move_forward', this).click(function(){ moveForward(current_slider, total_items); });
	jQuery('.move_backward', this).click(function(){ moveBackward(current_slider, total_items); });
	
	// If more than one item exists
	if(total_items > 1){
	  // Automatically advance slides only if autoAdvance is enabled
	  if( autoAdvance == true ){
		// Cycle through panels
		setInterval(function(){
		  moveForward(current_slider, total_items);
		}, (timeDelay * 1000) );
	  }
	}
	else {
		jQuery('.promo_slider_nav', this).hide();
	}
	
  });
  
  // Move forward
  function moveForward(slider_object, total_items){
	  
	  // Find number of current panel
	  var current_value = Number(jQuery('.current', slider_object).attr('value'));

	  // Update number to new panel
	  var new_value = current_value + 1;
	  if(new_value > total_items){new_value = 1;}
	  
	  // Assign variables for ease of use
	  var cur_item = jQuery('.panel-' + current_value, slider_object);
	  var new_item = jQuery('.panel-' + new_value, slider_object);
	  
	  // Add / Remove classes
	  cur_item.removeClass('current');
	  new_item.addClass('current');
	  
	  // Fade in / out
	  cur_item.fadeOut('fast', function(){
		new_item.fadeIn('fast');
	  });

  }
  
  // Move backward
  function moveBackward(slider_object, total_items){	  
	  
	  // Find number of current panel
	  var current_value = Number(jQuery('.current').attr('value'));
	  
	  // Update number to new panel
	  var new_value = current_value - 1;
	  if(new_value == 0){new_value = total_items;}
	  
	  // Assign variables for ease of use
	  var cur_item = jQuery('.panel-' + current_value, slider_object);
	  var new_item = jQuery('.panel-' + new_value, slider_object);
	  
	  // Add / Remove classes
	  cur_item.removeClass('current');
	  new_item.addClass('current');
	  
	  // Fade in / out
	  cur_item.fadeOut('fast', function(){
		new_item.fadeIn('fast');
	  });
  }

});